#include <string.h>
#include <conio.h>
#include <stdio.h>

/*

 STRING.H

Functions

 _fmemccpy    _fmemchr     _fmemcmp     _fmemcpy     _fmemicmp
 _fmemset     _fstrcat     _fstrchr     _fstrcmp     _fstrcpy
 _fstrcspn    _fstrdup     _fstricmp    _fstrlen     _fstrlwr
 _fstrncat    _fstrncmp    _fstrnicmp   _fstrncpy    _fstrnset
 _fstrpbrk    _fstrrchr    _fstrrev     _fstrset     _fstrspn
 _fstrstr     _fstrtok     _fstrupr     memccpy      memchr
 memcmp       memcpy       memicmp      memmove      memset
 movedata     movmem       setmem       stpcpy       strcat
 strchr       strcmp       strcmpi      strcpy       strcspn
 strdup       _strerror    strerror     stricmp      strlen
 strlwr       strncat      strncmp      strncmpi     strncpy
 strnicmp     strnset      strpbrk      strrchr      strrev
 strset       strspn       strstr       strtok       strxfrm
 strupr

Constants, data types, and global variables

 size_t
*/

int strcmp1(const char* , const char* );
int strcmp2(const char* , const char* );

void strcpy1(char* , const char* );
void strcpy2(char* , const char* );

void delete_ (char*, char);
void insert (char*, char,int,int,int);

void main()
 {
		char wiersz[10];
		char *wiersz1 = "abcdabcda";

		clrscr();
		strcpy(wiersz, wiersz1);
		printf("%s\n", wiersz);
		strcpy2(wiersz, wiersz1);
		printf("%s\n", wiersz);


		char *buf1 = "d", *buf2 = "aa";
		int por;

		por = strcmp(buf2, buf1);
		if (por > 0)
			 printf("lancuch2>lancuch1\n");
		else
		 if (por==0)
			 printf("lancuch2==lancuch1\n");
		 else
			 printf("lancuch2<lancuch1\n");

		por = strcmp2(buf2, buf1);
		if (por > 0)
			 printf("lancuch2>lancuch1\n");
		else
		 if (por==0)
			 printf("lancuch2==lancuch1\n");
		 else
			 printf("lancuch2<lancuch1\n");

	 delete_(wiersz,'b');
	 printf("%s\n",wiersz);
	 insert(wiersz,'b',1,10,strlen(wiersz));
	 printf("%s\n",wiersz);
	 getch();
}


void strcpy1(char* a, const char* b)
 {
	 int i=0;
	 a[i]=b[i];
	 while(b[i])
		{ i++;
		  a[i]=b[i];
		}
 }

void strcpy2(char* a, const char* b)
 {
	 *a=*b;
	 while (*b)
 		{b++;
		 a++;
		*a=*b;}
 }

int strcmp1(const char* a, const char* b)
 {
        int i= 0;
	while((a[i] == b[i]) && a[i]!=0 && b[i]!=0)
			 i++;

	if (a[i]>b[i]) return 1;
	else
	 if(a[i]==b[i])	return 0;
	 else  return -1;
 }

int strcmp2(const char* a, const char* b)
 {
	while((*a == *b) && *a!=0 && *b!=0)
	       {a++;
		b++;};

	if (*a>*b) return 1;
	else
	 if(*a==*b)	return 0;
	 else  return -1;
 }

void delete_ (char* a, char b)
 {int j,i=0;
  while (a[i])
	 {
 	  if (a[i]==b)
	    {
	     j=i;
	     while(a[j])
		{
		 a[j]=a[j+1];
		 j++;
		}
	     continue;
	    }
	   i++;
	 }
 }

void insert (char* a, char c, int gdzie, int rozmiar, int ile)
 {
  int i=0;
  if (ile+1>=rozmiar || ile<0) return;

  if (gdzie>=0 && gdzie<=ile)
	{ i=ile+1;                 //nowe polozenie znaku 0
	  while(i> gdzie)
	   {
		a[i]=a[i-1];
		i--;
	   }
	 a[gdzie]=c;
	}
 }
